﻿Public Class frmTest

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Init()
    End Sub

    Private Sub Init()
        '
        Try
            '
            Dim ds As New DataSet
            Dim dt1 As New DataTable
            Dim dt2 As New DataTable
            Dim row As DataRow

            Dim DataTypeColInteger As Type = GetType(Integer)
            Dim DataTypeColString As Type = GetType(String)
            Dim DataTypeColSingle As Type = GetType(Single)

            ' Parent
            dt1.Columns.Add("ID", DataTypeColInteger)
            dt1.Columns.Add("ProjectID", DataTypeColString)
            dt1.Columns.Add("BuildingID", DataTypeColString)
            dt1.Columns.Add("ModuleID", DataTypeColString)
            dt1.Columns.Add("ElementID", DataTypeColString)

            row = dt1.Rows.Add
            row.Item("ID") = 1
            row.Item("ProjectID") = "Projekt 1"
            row.Item("BuildingID") = "Byggnad 1"
            row.Item("ModuleID") = "Modul 1"
            row.Item("ElementID") = "YV01"

            row = dt1.Rows.Add
            row.Item("ID") = 2
            row.Item("ProjectID") = "Projekt 1"
            row.Item("BuildingID") = "Byggnad 1"
            row.Item("ModuleID") = "Modul 1"
            row.Item("ElementID") = "YV02"

            row = dt1.Rows.Add
            row.Item("ID") = 3
            row.Item("ProjectID") = "Projekt 1"
            row.Item("BuildingID") = "Byggnad 1"
            row.Item("ModuleID") = "Modul 2"
            row.Item("ElementID") = "YV03"

            row = dt1.Rows.Add
            row.Item("ID") = 4
            row.Item("ProjectID") = "Projekt 1"
            row.Item("BuildingID") = "Byggnad 1"
            row.Item("ModuleID") = "Modul 2"
            row.Item("ElementID") = "YV04"

            ds.Tables.Add(dt1)

            ' Child
            dt2.Columns.Add("ID", DataTypeColInteger)
            dt2.Columns.Add("Product", DataTypeColString)
            dt2.Columns.Add("Weight", DataTypeColSingle)
            dt2.Columns.Add("Price", DataTypeColSingle)

            row = dt2.Rows.Add
            row.Item("ID") = 1
            row.Item("Product") = "Beam"
            row.Item("Weight") = 1
            row.Item("Price") = 10

            row = dt2.Rows.Add
            row.Item("ID") = 1
            row.Item("Product") = "Beam"
            row.Item("Weight") = 1
            row.Item("Price") = 10

            row = dt2.Rows.Add
            row.Item("ID") = 2
            row.Item("Product") = "Beam"
            row.Item("Weight") = 1
            row.Item("Price") = 10

            row = dt2.Rows.Add
            row.Item("ID") = 2
            row.Item("Product") = "Beam"
            row.Item("Weight") = 1
            row.Item("Price") = 10

            row = dt2.Rows.Add
            row.Item("ID") = 3
            row.Item("Product") = "Beam"
            row.Item("Weight") = 1
            row.Item("Price") = 10

            row = dt2.Rows.Add
            row.Item("ID") = 3
            row.Item("Product") = "Beam"
            row.Item("Weight") = 1
            row.Item("Price") = 10

            row = dt2.Rows.Add
            row.Item("ID") = 4
            row.Item("Product") = "Beam"
            row.Item("Weight") = 1
            row.Item("Price") = 10

            row = dt2.Rows.Add
            row.Item("ID") = 4
            row.Item("Product") = "Beam"
            row.Item("Weight") = 1
            row.Item("Price") = 10

            ds.Tables.Add(dt2)

            ' Relation
            Dim rel As New DataRelation("ds1", ds.Tables(0).Columns("ID"), ds.Tables(1).Columns("ID"))
            ds.Relations.Add(rel)

            ug.DataSource = ds
            ug.DataBind()
            '
        Catch ex As Exception
            '

            '
        End Try
        '
    End Sub

    Private Sub ug_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles ug.InitializeLayout
        '
        Me.ug.DisplayLayout.Override.AllowRowSummaries = Infragistics.Win.UltraWinGrid.AllowRowSummaries.False
        Me.ug.DisplayLayout.Override.SummaryDisplayArea = Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.Bottom Or Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.InGroupByRows
        Me.ug.DisplayLayout.Override.SummaryFooterCaptionVisible = Infragistics.Win.DefaultableBoolean.False
        Me.ug.DisplayLayout.Override.GroupBySummaryDisplayStyle = Infragistics.Win.UltraWinGrid.GroupBySummaryDisplayStyle.SummaryCells


        Me.ug.DisplayLayout.Bands(1).Summaries.Add("Weight", Infragistics.Win.UltraWinGrid.SummaryType.Sum, Me.ug.DisplayLayout.Bands(1).Columns("Weight"), Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn)
        Me.ug.DisplayLayout.Bands(1).Summaries.Item(0).Appearance.TextHAlign = Infragistics.Win.HAlign.Right

        Me.ug.DisplayLayout.Bands(1).Summaries.Add("Price", Infragistics.Win.UltraWinGrid.SummaryType.Sum, Me.ug.DisplayLayout.Bands(1).Columns("Price"), Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn)
        Me.ug.DisplayLayout.Bands(1).Summaries.Item(1).Appearance.TextHAlign = Infragistics.Win.HAlign.Right
        '
    End Sub

End Class